/**
 * Generated Driver File
 * 
 * @file pins.c
 * 
 * @ingroup  pinsdriver
 * 
 * @brief This is generated driver implementation for pins. 
 *        This file provides implementations for pin APIs for all pins selected in the GUI.
 *
 * @version Driver Version 1.1.0
*/

/*
? [2023] Microchip Technology Inc. and its subsidiaries.

    Subject to your compliance with these terms, you may use Microchip 
    software and any derivatives exclusively with Microchip products. 
    You are responsible for complying with 3rd party license terms  
    applicable to your use of 3rd party software (including open source  
    software) that may accompany Microchip software. SOFTWARE IS ?AS IS.? 
    NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS 
    SOFTWARE, INCLUDING ANY IMPLIED WARRANTIES OF NON-INFRINGEMENT,  
    MERCHANTABILITY, OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT 
    WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY 
    KIND WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF 
    MICROCHIP HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE 
    FORESEEABLE. TO THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP?S 
    TOTAL LIABILITY ON ALL CLAIMS RELATED TO THE SOFTWARE WILL NOT 
    EXCEED AMOUNT OF FEES, IF ANY, YOU PAID DIRECTLY TO MICROCHIP FOR 
    THIS SOFTWARE.
*/

#include "../pins.h"

static void (*IO_PF5_InterruptHandler)(void);
static void (*IO_PF4_InterruptHandler)(void);
static void (*IO_PA3_InterruptHandler)(void);
static void (*IO_PA5_InterruptHandler)(void);
static void (*IO_PA4_InterruptHandler)(void);
static void (*IO_PA6_InterruptHandler)(void);
static void (*IO_PA1_InterruptHandler)(void);
static void (*IO_PA2_InterruptHandler)(void);
static void (*AIN0_PD0_InterruptHandler)(void);
static void (*SW3_PB0_InterruptHandler)(void);
static void (*SW4_PB1_InterruptHandler)(void);
static void (*DIR_C_InterruptHandler)(void);
static void (*DIR_D_InterruptHandler)(void);
static void (*DIR_A_InterruptHandler)(void);
static void (*DIR_B_InterruptHandler)(void);
static void (*DIR_CNT_InterruptHandler)(void);
static void (*SPI0CS_PA7_InterruptHandler)(void);
static void (*LED1_PB2_InterruptHandler)(void);
static void (*LED2_PB3_InterruptHandler)(void);
static void (*LED3_PB4_InterruptHandler)(void);
static void (*LED4_PB5_InterruptHandler)(void);
static void (*SDA_PC2_InterruptHandler)(void);
static void (*SCL_PC3_InterruptHandler)(void);
static void (*LDAC_PD7_InterruptHandler)(void);

void PIN_MANAGER_Initialize()
{
  /* DIR Registers Initialization */
    PORTA.DIR = 0xDE;
    PORTB.DIR = 0x3C;
    PORTC.DIR = 0xC;
    PORTD.DIR = 0x80;
    PORTE.DIR = 0x0;
    PORTF.DIR = 0x10;

  /* OUT Registers Initialization */
    PORTA.OUT = 0x82;
    PORTB.OUT = 0x4;
    PORTC.OUT = 0x0;
    PORTD.OUT = 0x80;
    PORTE.OUT = 0x0;
    PORTF.OUT = 0x10;

  /* PINxCTRL registers Initialization */
    PORTA.PIN0CTRL = 0x0;
    PORTA.PIN1CTRL = 0x0;
    PORTA.PIN2CTRL = 0x0;
    PORTA.PIN3CTRL = 0x0;
    PORTA.PIN4CTRL = 0x0;
    PORTA.PIN5CTRL = 0x0;
    PORTA.PIN6CTRL = 0x0;
    PORTA.PIN7CTRL = 0x0;
    PORTB.PIN0CTRL = 0x0;
    PORTB.PIN1CTRL = 0x0;
    PORTB.PIN2CTRL = 0x0;
    PORTB.PIN3CTRL = 0x0;
    PORTB.PIN4CTRL = 0x0;
    PORTB.PIN5CTRL = 0x0;
    PORTB.PIN6CTRL = 0x0;
    PORTB.PIN7CTRL = 0x0;
    PORTC.PIN0CTRL = 0x0;
    PORTC.PIN1CTRL = 0x0;
    PORTC.PIN2CTRL = 0x0;
    PORTC.PIN3CTRL = 0x0;
    PORTC.PIN4CTRL = 0x0;
    PORTC.PIN5CTRL = 0x0;
    PORTC.PIN6CTRL = 0x0;
    PORTC.PIN7CTRL = 0x0;
    PORTD.PIN0CTRL = 0x0;
    PORTD.PIN1CTRL = 0x0;
    PORTD.PIN2CTRL = 0x0;
    PORTD.PIN3CTRL = 0x0;
    PORTD.PIN4CTRL = 0x0;
    PORTD.PIN5CTRL = 0x0;
    PORTD.PIN6CTRL = 0x0;
    PORTD.PIN7CTRL = 0x0;
    PORTE.PIN0CTRL = 0x0;
    PORTE.PIN1CTRL = 0x0;
    PORTE.PIN2CTRL = 0x0;
    PORTE.PIN3CTRL = 0x0;
    PORTE.PIN4CTRL = 0x0;
    PORTE.PIN5CTRL = 0x0;
    PORTE.PIN6CTRL = 0x0;
    PORTE.PIN7CTRL = 0x0;
    PORTF.PIN0CTRL = 0x0;
    PORTF.PIN1CTRL = 0x0;
    PORTF.PIN2CTRL = 0x0;
    PORTF.PIN3CTRL = 0x0;
    PORTF.PIN4CTRL = 0x0;
    PORTF.PIN5CTRL = 0x0;
    PORTF.PIN6CTRL = 0x0;
    PORTF.PIN7CTRL = 0x0;

  /* PORTMUX Initialization */
    PORTMUX.ACROUTEA = 0x0;
    PORTMUX.CCLROUTEA = 0x0;
    PORTMUX.EVSYSROUTEA = 0x0;
    PORTMUX.SPIROUTEA = 0x0;
    PORTMUX.TCAROUTEA = 0x0;
    PORTMUX.TCBROUTEA = 0x0;
    PORTMUX.TCDROUTEA = 0x2;
    PORTMUX.TWIROUTEA = 0x0;
    PORTMUX.USARTROUTEA = 0x10;
    PORTMUX.USARTROUTEB = 0x0;
    PORTMUX.ZCDROUTEA = 0x0;

  // register default ISC callback functions at runtime; use these methods to register a custom function
    IO_PF5_SetInterruptHandler(IO_PF5_DefaultInterruptHandler);
    IO_PF4_SetInterruptHandler(IO_PF4_DefaultInterruptHandler);
    IO_PA3_SetInterruptHandler(IO_PA3_DefaultInterruptHandler);
    IO_PA5_SetInterruptHandler(IO_PA5_DefaultInterruptHandler);
    IO_PA4_SetInterruptHandler(IO_PA4_DefaultInterruptHandler);
    IO_PA6_SetInterruptHandler(IO_PA6_DefaultInterruptHandler);
    IO_PA1_SetInterruptHandler(IO_PA1_DefaultInterruptHandler);
    IO_PA2_SetInterruptHandler(IO_PA2_DefaultInterruptHandler);
    AIN0_PD0_SetInterruptHandler(AIN0_PD0_DefaultInterruptHandler);
    SW3_PB0_SetInterruptHandler(SW3_PB0_DefaultInterruptHandler);
    SW4_PB1_SetInterruptHandler(SW4_PB1_DefaultInterruptHandler);
    DIR_C_SetInterruptHandler(DIR_C_DefaultInterruptHandler);
    DIR_D_SetInterruptHandler(DIR_D_DefaultInterruptHandler);
    DIR_A_SetInterruptHandler(DIR_A_DefaultInterruptHandler);
    DIR_B_SetInterruptHandler(DIR_B_DefaultInterruptHandler);
    DIR_CNT_SetInterruptHandler(DIR_CNT_DefaultInterruptHandler);
    SPI0CS_PA7_SetInterruptHandler(SPI0CS_PA7_DefaultInterruptHandler);
    LED1_PB2_SetInterruptHandler(LED1_PB2_DefaultInterruptHandler);
    LED2_PB3_SetInterruptHandler(LED2_PB3_DefaultInterruptHandler);
    LED3_PB4_SetInterruptHandler(LED3_PB4_DefaultInterruptHandler);
    LED4_PB5_SetInterruptHandler(LED4_PB5_DefaultInterruptHandler);
    SDA_PC2_SetInterruptHandler(SDA_PC2_DefaultInterruptHandler);
    SCL_PC3_SetInterruptHandler(SCL_PC3_DefaultInterruptHandler);
    LDAC_PD7_SetInterruptHandler(LDAC_PD7_DefaultInterruptHandler);
}

/**
  Allows selecting an interrupt handler for IO_PF5 at application runtime
*/
void IO_PF5_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    IO_PF5_InterruptHandler = interruptHandler;
}

void IO_PF5_DefaultInterruptHandler(void)
{
    // add your IO_PF5 interrupt custom code
    // or set custom function using IO_PF5_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for IO_PF4 at application runtime
*/
void IO_PF4_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    IO_PF4_InterruptHandler = interruptHandler;
}

void IO_PF4_DefaultInterruptHandler(void)
{
    // add your IO_PF4 interrupt custom code
    // or set custom function using IO_PF4_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for IO_PA3 at application runtime
*/
void IO_PA3_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    IO_PA3_InterruptHandler = interruptHandler;
}

void IO_PA3_DefaultInterruptHandler(void)
{
    // add your IO_PA3 interrupt custom code
    // or set custom function using IO_PA3_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for IO_PA5 at application runtime
*/
void IO_PA5_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    IO_PA5_InterruptHandler = interruptHandler;
}

void IO_PA5_DefaultInterruptHandler(void)
{
    // add your IO_PA5 interrupt custom code
    // or set custom function using IO_PA5_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for IO_PA4 at application runtime
*/
void IO_PA4_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    IO_PA4_InterruptHandler = interruptHandler;
}

void IO_PA4_DefaultInterruptHandler(void)
{
    // add your IO_PA4 interrupt custom code
    // or set custom function using IO_PA4_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for IO_PA6 at application runtime
*/
void IO_PA6_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    IO_PA6_InterruptHandler = interruptHandler;
}

void IO_PA6_DefaultInterruptHandler(void)
{
    // add your IO_PA6 interrupt custom code
    // or set custom function using IO_PA6_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for IO_PA1 at application runtime
*/
void IO_PA1_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    IO_PA1_InterruptHandler = interruptHandler;
}

void IO_PA1_DefaultInterruptHandler(void)
{
    // add your IO_PA1 interrupt custom code
    // or set custom function using IO_PA1_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for IO_PA2 at application runtime
*/
void IO_PA2_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    IO_PA2_InterruptHandler = interruptHandler;
}

void IO_PA2_DefaultInterruptHandler(void)
{
    // add your IO_PA2 interrupt custom code
    // or set custom function using IO_PA2_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for AIN0_PD0 at application runtime
*/
void AIN0_PD0_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    AIN0_PD0_InterruptHandler = interruptHandler;
}

void AIN0_PD0_DefaultInterruptHandler(void)
{
    // add your AIN0_PD0 interrupt custom code
    // or set custom function using AIN0_PD0_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for SW3_PB0 at application runtime
*/
void SW3_PB0_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    SW3_PB0_InterruptHandler = interruptHandler;
}

void SW3_PB0_DefaultInterruptHandler(void)
{
    // add your SW3_PB0 interrupt custom code
    // or set custom function using SW3_PB0_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for SW4_PB1 at application runtime
*/
void SW4_PB1_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    SW4_PB1_InterruptHandler = interruptHandler;
}

void SW4_PB1_DefaultInterruptHandler(void)
{
    // add your SW4_PB1 interrupt custom code
    // or set custom function using SW4_PB1_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for DIR_C at application runtime
*/
void DIR_C_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    DIR_C_InterruptHandler = interruptHandler;
}

void DIR_C_DefaultInterruptHandler(void)
{
    // add your DIR_C interrupt custom code
    // or set custom function using DIR_C_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for DIR_D at application runtime
*/
void DIR_D_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    DIR_D_InterruptHandler = interruptHandler;
}

void DIR_D_DefaultInterruptHandler(void)
{
    // add your DIR_D interrupt custom code
    // or set custom function using DIR_D_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for DIR_A at application runtime
*/
void DIR_A_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    DIR_A_InterruptHandler = interruptHandler;
}

void DIR_A_DefaultInterruptHandler(void)
{
    // add your DIR_A interrupt custom code
    // or set custom function using DIR_A_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for DIR_B at application runtime
*/
void DIR_B_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    DIR_B_InterruptHandler = interruptHandler;
}

void DIR_B_DefaultInterruptHandler(void)
{
    // add your DIR_B interrupt custom code
    // or set custom function using DIR_B_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for DIR_CNT at application runtime
*/
void DIR_CNT_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    DIR_CNT_InterruptHandler = interruptHandler;
}

void DIR_CNT_DefaultInterruptHandler(void)
{
    // add your DIR_CNT interrupt custom code
    // or set custom function using DIR_CNT_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for SPI0CS_PA7 at application runtime
*/
void SPI0CS_PA7_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    SPI0CS_PA7_InterruptHandler = interruptHandler;
}

void SPI0CS_PA7_DefaultInterruptHandler(void)
{
    // add your SPI0CS_PA7 interrupt custom code
    // or set custom function using SPI0CS_PA7_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for LED1_PB2 at application runtime
*/
void LED1_PB2_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    LED1_PB2_InterruptHandler = interruptHandler;
}

void LED1_PB2_DefaultInterruptHandler(void)
{
    // add your LED1_PB2 interrupt custom code
    // or set custom function using LED1_PB2_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for LED2_PB3 at application runtime
*/
void LED2_PB3_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    LED2_PB3_InterruptHandler = interruptHandler;
}

void LED2_PB3_DefaultInterruptHandler(void)
{
    // add your LED2_PB3 interrupt custom code
    // or set custom function using LED2_PB3_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for LED3_PB4 at application runtime
*/
void LED3_PB4_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    LED3_PB4_InterruptHandler = interruptHandler;
}

void LED3_PB4_DefaultInterruptHandler(void)
{
    // add your LED3_PB4 interrupt custom code
    // or set custom function using LED3_PB4_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for LED4_PB5 at application runtime
*/
void LED4_PB5_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    LED4_PB5_InterruptHandler = interruptHandler;
}

void LED4_PB5_DefaultInterruptHandler(void)
{
    // add your LED4_PB5 interrupt custom code
    // or set custom function using LED4_PB5_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for SDA_PC2 at application runtime
*/
void SDA_PC2_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    SDA_PC2_InterruptHandler = interruptHandler;
}

void SDA_PC2_DefaultInterruptHandler(void)
{
    // add your SDA_PC2 interrupt custom code
    // or set custom function using SDA_PC2_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for SCL_PC3 at application runtime
*/
void SCL_PC3_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    SCL_PC3_InterruptHandler = interruptHandler;
}

void SCL_PC3_DefaultInterruptHandler(void)
{
    // add your SCL_PC3 interrupt custom code
    // or set custom function using SCL_PC3_SetInterruptHandler()
}
/**
  Allows selecting an interrupt handler for LDAC_PD7 at application runtime
*/
void LDAC_PD7_SetInterruptHandler(void (* interruptHandler)(void)) 
{
    LDAC_PD7_InterruptHandler = interruptHandler;
}

void LDAC_PD7_DefaultInterruptHandler(void)
{
    // add your LDAC_PD7 interrupt custom code
    // or set custom function using LDAC_PD7_SetInterruptHandler()
}
ISR(PORTA_PORT_vect)
{ 
    // Call the interrupt handler for the callback registered at runtime
    if(VPORTA.INTFLAGS & PORT_INT3_bm)
    {
       IO_PA3_InterruptHandler(); 
    }
    if(VPORTA.INTFLAGS & PORT_INT5_bm)
    {
       IO_PA5_InterruptHandler(); 
    }
    if(VPORTA.INTFLAGS & PORT_INT4_bm)
    {
       IO_PA4_InterruptHandler(); 
    }
    if(VPORTA.INTFLAGS & PORT_INT6_bm)
    {
       IO_PA6_InterruptHandler(); 
    }
    if(VPORTA.INTFLAGS & PORT_INT1_bm)
    {
       IO_PA1_InterruptHandler(); 
    }
    if(VPORTA.INTFLAGS & PORT_INT2_bm)
    {
       IO_PA2_InterruptHandler(); 
    }
    if(VPORTA.INTFLAGS & PORT_INT7_bm)
    {
       SPI0CS_PA7_InterruptHandler(); 
    }
    /* Clear interrupt flags */
    VPORTA.INTFLAGS = 0xff;
}

ISR(PORTB_PORT_vect)
{ 
    // Call the interrupt handler for the callback registered at runtime
    if(VPORTB.INTFLAGS & PORT_INT0_bm)
    {
       SW3_PB0_InterruptHandler(); 
    }
    if(VPORTB.INTFLAGS & PORT_INT1_bm)
    {
       SW4_PB1_InterruptHandler(); 
    }
    if(VPORTB.INTFLAGS & PORT_INT2_bm)
    {
       LED1_PB2_InterruptHandler(); 
    }
    if(VPORTB.INTFLAGS & PORT_INT3_bm)
    {
       LED2_PB3_InterruptHandler(); 
    }
    if(VPORTB.INTFLAGS & PORT_INT4_bm)
    {
       LED3_PB4_InterruptHandler(); 
    }
    if(VPORTB.INTFLAGS & PORT_INT5_bm)
    {
       LED4_PB5_InterruptHandler(); 
    }
    /* Clear interrupt flags */
    VPORTB.INTFLAGS = 0xff;
}

ISR(PORTC_PORT_vect)
{ 
    // Call the interrupt handler for the callback registered at runtime
    if(VPORTC.INTFLAGS & PORT_INT2_bm)
    {
       SDA_PC2_InterruptHandler(); 
    }
    if(VPORTC.INTFLAGS & PORT_INT3_bm)
    {
       SCL_PC3_InterruptHandler(); 
    }
    /* Clear interrupt flags */
    VPORTC.INTFLAGS = 0xff;
}

ISR(PORTD_PORT_vect)
{ 
    // Call the interrupt handler for the callback registered at runtime
    if(VPORTD.INTFLAGS & PORT_INT0_bm)
    {
       AIN0_PD0_InterruptHandler(); 
    }
    if(VPORTD.INTFLAGS & PORT_INT1_bm)
    {
       DIR_C_InterruptHandler(); 
    }
    if(VPORTD.INTFLAGS & PORT_INT2_bm)
    {
       DIR_D_InterruptHandler(); 
    }
    if(VPORTD.INTFLAGS & PORT_INT4_bm)
    {
       DIR_A_InterruptHandler(); 
    }
    if(VPORTD.INTFLAGS & PORT_INT5_bm)
    {
       DIR_B_InterruptHandler(); 
    }
    if(VPORTD.INTFLAGS & PORT_INT7_bm)
    {
       LDAC_PD7_InterruptHandler(); 
    }
    /* Clear interrupt flags */
    VPORTD.INTFLAGS = 0xff;
}

ISR(PORTE_PORT_vect)
{ 
    // Call the interrupt handler for the callback registered at runtime
    if(VPORTE.INTFLAGS & PORT_INT0_bm)
    {
       DIR_CNT_InterruptHandler(); 
    }
    /* Clear interrupt flags */
    VPORTE.INTFLAGS = 0xff;
}

ISR(PORTF_PORT_vect)
{ 
    // Call the interrupt handler for the callback registered at runtime
    if(VPORTF.INTFLAGS & PORT_INT5_bm)
    {
       IO_PF5_InterruptHandler(); 
    }
    if(VPORTF.INTFLAGS & PORT_INT4_bm)
    {
       IO_PF4_InterruptHandler(); 
    }
    /* Clear interrupt flags */
    VPORTF.INTFLAGS = 0xff;
}

/**
 End of File
*/